//
//  ViewController.m
//  GCBLocationTest
//
//  Created by panjingjie on 16/8/25.
//  Copyright © 2016年 ZH. All rights reserved.
//

#import "ViewController.h"
#import <CoreLocation/CoreLocation.h>

@interface ViewController ()<CLLocationManagerDelegate>
{
    CLLocationManager * locationManager;
    NSString * currentCity;//当前城市
    UILabel *label;
    UILabel *label1;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    label = [[UILabel alloc]init];
    label.frame = CGRectMake(100, 200, 80, 50);
    label.backgroundColor = [UIColor yellowColor];
    [self.view addSubview:label];
    
    label1 = [[UILabel alloc]init];
    label1.frame = CGRectMake(0, 300, self.view.frame.size.width, 50);
    label1.backgroundColor = [UIColor redColor];
    [self.view addSubview:label1];
    [self locate];
}

-(void)locate{
    //判断定位功能是否打开
    if ([CLLocationManager locationServicesEnabled]) {
        locationManager = [[CLLocationManager alloc]init];
        locationManager.delegate = self;
//        [locationManager requestWhenInUseAuthorization];
        [locationManager requestAlwaysAuthorization];
        currentCity = [[NSString alloc]init];
        [locationManager startUpdatingLocation];
    }
    
}

#pragma mark CoreLocation delegate

//定位失败则执行此代理方法
//定位失败弹出提示框，点击"打开定位"按钮,则会打开系统的设置，提示打开定位服务

-(void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error{
    UIAlertController *alertVC = [UIAlertController alertControllerWithTitle:@"允许\"定位\"提示" message:@"请在设置中打开定位" preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction * ok = [UIAlertAction actionWithTitle:@"打开定位" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        //打开定位设置
        NSURL *settinsURL = [NSURL URLWithString:UIApplicationOpenSettingsURLString];
        [[UIApplication sharedApplication] openURL:settinsURL];
    }];
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
    }];
    [alertVC addAction:cancel];
    [alertVC addAction:ok];
    [self presentViewController:alertVC animated:YES completion:nil];
}

//定位成功
-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray<CLLocation *> *)locations{
    
    CLLocation *currentLocation = [locations lastObject];
    CLGeocoder *geoCoder = [[CLGeocoder alloc]init];
    
    //反编码
    [geoCoder reverseGeocodeLocation:currentLocation completionHandler:^(NSArray<CLPlacemark *> * _Nullable placemarks, NSError * _Nullable error) {
        if (placemarks.count > 0) {
            CLPlacemark *placeMark = placemarks[0];
            currentCity = placeMark.locality;
            if (!currentCity) {
                currentCity = @"无法定位当前城市";
            }
            label.text = currentCity;
            [label setTextAlignment:NSTextAlignmentCenter];
            NSLog(@"%@",currentCity); //这就是当前的城市
            label1.text = placeMark.name;
            [label1 setTextAlignment:NSTextAlignmentCenter];
            
            NSLog(@"%@",placeMark.name);//具体地址:  xx市xx区xx街道
        }else if (error == nil && placemarks.count == 0){
            NSLog(@"No location and error return");;
        }else if (error){
            NSLog(@"location error: %@ ",error);
        }
    }];
    [locationManager stopUpdatingLocation];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
